# -*- coding: utf-8 -*-
##################################################
# This file is part of WAPT Enterprise
# All right reserved, (c) Tranquil IT Systems 2023
# For more information please refer to
# https://wapt.tranquil.it/store/licences.html
##################################################
from setuphelpers import *
import json
import re
import requests


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    base_url = "https://cdn.zabbix.com/zabbix/binaries/stable/"
    re_versions = re.compile(r'<a href="([\d\.]+)/?">')

    # Récupération du contenu HTML de l'URL de base
    index = wgets(base_url, proxies=proxies)

    # Recherche des versions dans le contenu HTML
    versions = re_versions.findall(index)

    # Si des versions sont trouvées
    if versions:
        # Prendre la première version trouvée (ou la version la plus récente si déjà triée)
        latest_version = sorted(versions, key=lambda p: Version(p), reverse=True)[0]

        # Construire l'URL spécifique pour cette version
        url_zabbix = base_url + latest_version + "/"
        index_version = wgets(url_zabbix, proxies=proxies)

        # Rechercher la version spécifique (par exemple, 7.0.0)
        re_specific_version = re.compile(r'<a href="([\d\.]+?)/">')

        # Rechercher la version spécifique dans le contenu HTML
        specific_versions = re_specific_version.findall(index_version)

        # Si des versions spécifiques sont trouvées
        if specific_versions:
            # Prendre la première version spécifique trouvée (ou la version la plus récente si déjà triée)
            latest_specific_version = sorted(specific_versions, key=lambda p: Version(p), reverse=True)[0]
            if control.architecture == "x64":
                # Construire le nom du fichier MSI à partir de la version spécifique
                msi_filename = f"zabbix_agent-{latest_specific_version}-windows-amd64-openssl.msi"
                version = msi_filename.split("-")[1]
                download_url = "https://cdn.zabbix.com/zabbix/binaries/stable/%s" %latest_version +  "/" + latest_specific_version + "/" + msi_filename

        

                # remove files
                for f in glob.glob("*.msi"):
                    if f != msi_filename:
                        remove_file(f)

                # Downloading latest binaries
                wget(download_url, msi_filename, proxies=proxies)

                version =get_version_from_binary(msi_filename)

                control.set_software_version(version)
                control.save_control_to_wapt()
